      program gold
      integer n,i
      parameter (n=4000)
      integer numpairs(n)
      logical conject
c
c 1) Initialise numpairs to 0, the array which will contain the
c    data for the number of Goldbach pairs for the first n even
c    numbers
c




c
c 2) Create a do loop for i = 1, n and call subroutine "goldbach" for
c    each iteration with the arguments 2*i and numpairs(i). This is the
c    loop to parallise.
c


c
c 3) Test to see if the conjecture is true, ie that there is at least
c    one Goldbach pair for each even number.
c

c
c 4) Output selected results
c
      do i=1,n,n/10
         print *, 2*i, numpairs(i)
      end do
c
      stop
      end
c
c
c
      subroutine goldbach(evenno,numpairs)
c
      integer evenno,numpairs,j
      logical isprime
c
      numpairs = 0
      do j=2,evenno/2
         if (isprime(j).and.isprime(evenno-j)) numpairs = numpairs + 1
      end do
c
      return
      end
c
c
c
      logical function isprime(num)
c
      integer num,i
c
C
C CRUDE PRIMALITY TEST: CHECKS ALL INTEGERS LESS THAN SQUARE ROOT
C OF NUMBER
C
      if (num .eq. 1) then 
         isprime = .false. 
         return
      endif 
      isprime = .true.
      i=2
      do while ( (i.le.(int(sqrt(real(num)))) ) .and. isprime)
         isprime = mod(num,i).ne.0
         i=i+1
      end do
c
      return
      end

