      subroutine mxwell(vh,n3,h,tref)
      implicit double precision (a-h, o-z)
      dimension vh(1:n3)
c
c sample maxwell distribution at temperature tref
c
c alliant 3
      iseed = 4711
      ujunk = random(iseed)
      iseed = 0
      npart = n3/3
      iof1 = npart
      iof2 = npart*2
      tscale = 16.0d0 / (1.0d0 * npart - 1.0d0)
      do 10 i = 1,n3,2
c
c cray 2
c1         u1 = ranf()
c          u2 = ranf()
c alliant 2
1         u1 = random(iseed)
          u2 = random(iseed)
          v1 = 2.0d0 * u1 - 1.0d0
          v2 = 2.0d0 * u2 - 1.0d0
          s = v1*v1 + v2*v2
          if (s.ge.1.0) goto 1
c
          r = sqrt(-2.0d0*dlog(s)/s)
          vh(i) = v1 * r
          vh(i+1) = v2 * r
10    continue
c
      ekin = 0.0d0
      sp = 0.0d0
      do 20 i = 1,npart
          sp = sp + vh(i)
20    continue
      sp = sp / npart
      do 21 i = 1,npart
          vh(i) = vh(i) - sp
          ekin = ekin + vh(i)*vh(i)
21    continue
      sp = 0.0d0
      do 22 i = iof1 + 1,iof2
          sp = sp + vh(i)
22    continue
      sp = sp / npart
      do 23 i = iof1 + 1,iof2
          vh(i) = vh(i) - sp
          ekin = ekin + vh(i)*vh(i)
23    continue
      sp = 0.0d0
      do 24 i = iof2 + 1,n3
          sp = sp + vh(i)
24    continue
      sp = sp / npart
      do 25 i = iof2 + 1,n3
          vh(i) = vh(i) - sp
          ekin = ekin + vh(i)*vh(i)
25    continue
      ts = tscale * ekin
      sc = h * sqrt(tref/ts)
      do 30 i = 1,n3
          vh(i) = vh(i) * sc
30    continue
c
      end
